
/**************************************************************************************************
*IBM Public License Version 1.0 
*
*THE ACCOMPANYING PROGRAM IS PROVIDED UNDER THE TERMS OF THIS IBM PUBLIC LICENSE ("AGREEMENT"). ANY USE, REPRODUCTION OR DISTRIBUTION OF THE PROGRAM CONSTITUTES RECIPIENT'S ACCEPTANCE OF THIS AGREEMENT. 
*
*1. DEFINITIONS 
*
*"Contribution" means: 
*
*       a) in the case of International Business Machines Corporation ("IBM"), the Original Program, and 
*
*       b) in the case of each Contributor, 
*
*       i) changes to the Program, and
*
*       ii) additions to the Program;
*
*       where such changes and/or additions to the Program originate from and are distributed by that particular Contributor. A Contribution 'originates' from a Contributor if it
*       was added to the Program by such Contributor itself or anyone acting on such Contributor's behalf. Contributions do not include additions to the Program which: (i) are
*       separate modules of software distributed in conjunction with the Program under their own license agreement, and (ii) are not derivative works of the Program.
*
*  "Contributor" means IBM and any other entity that distributes the Program. 
*
*  "Licensed Patents " mean patent claims licensable by a Contributor which are necessarily infringed by the use or sale of its Contribution alone or when combined with the
*  Program. 
*
*  "Original Program" means the original version of the software accompanying this Agreement as released by IBM, including source code, object code and documentation, if
*  any. 
*
*  "Program" means the Original Program and Contributions. 
*
*  "Recipient" means anyone who receives the Program under this Agreement, including all Contributors. 
*
*  2. GRANT OF RIGHTS 
*
*       a) Subject to the terms of this Agreement, each Contributor hereby grants Recipient a non-exclusive, worldwide, royalty-free copyright license to reproduce, prepare
*       derivative works of, publicly display, publicly perform, distribute and sublicense the Contribution of such Contributor, if any, and such derivative works, in source code
*       and object code form.
*
*       b) Subject to the terms of this Agreement, each Contributor hereby grants Recipient a non-exclusive, worldwide, royalty-free patent license under Licensed Patents to
*       make, use, sell, offer to sell, import and otherwise transfer the Contribution of such Contributor, if any, in source code and object code form. This patent license shall
*       apply to the combination of the Contribution and the Program if, at the time the Contribution is added by the Contributor, such addition of the Contribution causes
*       such combination to be covered by the Licensed Patents. The patent license shall not apply to any other combinations which include the Contribution. No hardware per
*       se is licensed hereunder. 
*
*       c) Recipient understands that although each Contributor grants the licenses to its Contributions set forth herein, no assurances are provided by any Contributor that
*       the Program does not infringe the patent or other intellectual property rights of any other entity. Each Contributor disclaims any liability to Recipient for claims brought
*       by any other entity based on infringement of intellectual property rights or otherwise. As a condition to exercising the rights and licenses granted hereunder, each
*       Recipient hereby assumes sole responsibility to secure any other intellectual property rights needed, if any. For example, if a third party patent license is required to
*       allow Recipient to distribute the Program, it is Recipient's responsibility to acquire that license before distributing the Program.
*
*       d) Each Contributor represents that to its knowledge it has sufficient copyright rights in its Contribution, if any, to grant the copyright license set forth in this
*       Agreement. 
*
*  3. REQUIREMENTS 
*
*  A Contributor may choose to distribute the Program in object code form under its own license agreement, provided that: 
*
*       a) it complies with the terms and conditions of this Agreement; and
*
*       b) its license agreement:
*
*       i) effectively disclaims on behalf of all Contributors all warranties and conditions, express and implied, including warranties or conditions of title and non-infringement,
*       and implied warranties or conditions of merchantability and fitness for a particular purpose; 
*
*       ii) effectively excludes on behalf of all Contributors all liability for damages, including direct, indirect, special, incidental and consequential damages, such as lost
*       profits; 
*
*       iii) states that any provisions which differ from this Agreement are offered by that Contributor alone and not by any other party; and
*
*       iv) states that source code for the Program is available from such Contributor, and informs licensees how to obtain it in a reasonable manner on or through a medium
*       customarily used for software exchange. 
*
*  When the Program is made available in source code form: 
*
*       a) it must be made available under this Agreement; and 
*
*       b) a copy of this Agreement must be included with each copy of the Program. 
*
*  Each Contributor must include the following in a conspicuous location in the Program: 
*
*       Copyright  {date here}, International Business Machines Corporation and others. All Rights Reserved. 
*
*  In addition, each Contributor must identify itself as the originator of its Contribution, if any, in a manner that reasonably allows subsequent Recipients to identify the originator
*  of the Contribution. 
*
*  4. COMMERCIAL DISTRIBUTION 
*
*  Commercial distributors of software may accept certain responsibilities with respect to end users, business partners and the like. While this license is intended to facilitate the
*  commercial use of the Program, the Contributor who includes the Program in a commercial product offering should do so in a manner which does not create potential liability
*  for other Contributors. Therefore, if a Contributor includes the Program in a commercial product offering, such Contributor ("Commercial Contributor") hereby agrees to defend
*  and indemnify every other Contributor ("Indemnified Contributor") against any losses, damages and costs (collectively "Losses") arising from claims, lawsuits and other legal
*  actions brought by a third party against the Indemnified Contributor to the extent caused by the acts or omissions of such Commercial Contributor in connection with its
*  distribution of the Program in a commercial product offering. The obligations in this section do not apply to any claims or Losses relating to any actual or alleged intellectual
*  property infringement. In order to qualify, an Indemnified Contributor must: a) promptly notify the Commercial Contributor in writing of such claim, and b) allow the Commercial
*  Contributor to control, and cooperate with the Commercial Contributor in, the defense and any related settlement negotiations. The Indemnified Contributor may participate in
*  any such claim at its own expense. 
*
*  For example, a Contributor might include the Program in a commercial product offering, Product X. That Contributor is then a Commercial Contributor. If that Commercial
*  Contributor then makes performance claims, or offers warranties related to Product X, those performance claims and warranties are such Commercial Contributor's
*  responsibility alone. Under this section, the Commercial Contributor would have to defend claims against the other Contributors related to those performance claims and
*  warranties, and if a court requires any other Contributor to pay any damages as a result, the Commercial Contributor must pay those damages. 
*
*  5. NO WARRANTY 
*
*  EXCEPT AS EXPRESSLY SET FORTH IN THIS AGREEMENT, THE PROGRAM IS PROVIDED ON AN "AS IS" BASIS, WITHOUT WARRANTIES OR CONDITIONS OF ANY
*  KIND, EITHER EXPRESS OR IMPLIED INCLUDING, WITHOUT LIMITATION, ANY WARRANTIES OR CONDITIONS OF TITLE, NON-INFRINGEMENT,
*  MERCHANTABILITY OR FITNESS FOR A PARTICULAR PURPOSE. Each Recipient is solely responsible for determining the appropriateness of using and distributing the
*  Program and assumes all risks associated with its exercise of rights under this Agreement, including but not limited to the risks and costs of program errors, compliance with
*  applicable laws, damage to or loss of data, programs or equipment, and unavailability or interruption of operations. 
*
*  6. DISCLAIMER OF LIABILITY 
*
*  EXCEPT AS EXPRESSLY SET FORTH IN THIS AGREEMENT, NEITHER RECIPIENT NOR ANY CONTRIBUTORS SHALL HAVE ANY LIABILITY FOR ANY DIRECT,
*  INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING WITHOUT LIMITATION LOST PROFITS), HOWEVER CAUSED AND
*  ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT
*  OF THE USE OR DISTRIBUTION OF THE PROGRAM OR THE EXERCISE OF ANY RIGHTS GRANTED HEREUNDER, EVEN IF ADVISED OF THE POSSIBILITY OF
*  SUCH DAMAGES. 
*
*  7. GENERAL 
*
*  If any provision of this Agreement is invalid or unenforceable under applicable law, it shall not affect the validity or enforceability of the remainder of the terms of this
*  Agreement, and without further action by the parties hereto, such provision shall be reformed to the minimum extent necessary to make such provision valid and enforceable. 
*
*  If Recipient institutes patent litigation against a Contributor with respect to a patent applicable to software (including a cross-claim or counterclaim in a lawsuit), then any
*  patent licenses granted by that Contributor to such Recipient under this Agreement shall terminate as of the date such litigation is filed. In addition, If Recipient institutes
*  patent litigation against any entity (including a cross-claim or counterclaim in a lawsuit) alleging that the Program itself (excluding combinations of the Program with other
*  software or hardware) infringes such Recipient's patent(s), then such Recipient's rights granted under Section 2(b) shall terminate as of the date such litigation is filed. 
*
*  All Recipient's rights under this Agreement shall terminate if it fails to comply with any of the material terms or conditions of this Agreement and does not cure such failure in a
*  reasonable period of time after becoming aware of such noncompliance. If all Recipient's rights under this Agreement terminate, Recipient agrees to cease use and
*  distribution of the Program as soon as reasonably practicable. However, Recipient's obligations under this Agreement and any licenses granted by Recipient relating to the
*  Program shall continue and survive. 
*
*  IBM may publish new versions (including revisions) of this Agreement from time to time. Each new version of the Agreement will be given a distinguishing version number. The
*  Program (including Contributions) may always be distributed subject to the version of the Agreement under which it was received. In addition, after a new version of the
*  Agreement is published, Contributor may elect to distribute the Program (including its Contributions) under the new version. No one other than IBM has the right to modify this
*  Agreement. Except as expressly stated in Sections 2(a) and 2(b) above, Recipient receives no rights or licenses to the intellectual property of any Contributor under this
*  Agreement, whether expressly, by implication, estoppel or otherwise. All rights in the Program not expressly granted under this Agreement are reserved. 
*
*  This Agreement is governed by the laws of the State of New York and the intellectual property laws of the United States of America. No party to this Agreement will bring a
*  legal action under this Agreement more than one year after the cause of action arose. Each party waives its rights to a jury trial in any resulting litigation. 
**********************************************************************************************************************/
#ifndef bt_core_h
#define bt_core_h

#include "bt-def.h"
#include "random.h"
#include "connector.h"
#include "bi-connector.h"
#include "trace.h"
#include "queue.h"
#include "trafgen.h"
#include "globals.h"
#include <queue>
#include <list>

/*============================================================
			THE BASEBAND MODULE
============================================================*/

//**********************HELPER CLASSES************************

// Connection attributes received in HCI_Create_Connection
struct ConnectionRequest {
	int 	bd_addr;
	int 	clock_offset;
	uchar   packet_type;
};

class Baseband;

// Native clock (CLKN) Handler class
class CLKNHandler : public Handler {
public:
	CLKNHandler(Baseband* lm) : lm_(lm) {}
	void handle(Event* e);
	Baseband* lm_;
};

// Master clock (CLK) Handler class
class CLKHandler : public Handler {
public:
	CLKHandler(Baseband* lm) : lm_(lm) {}
	void handle(Event* e);
	Baseband* lm_;
};

// Handles received packets destined for a device
class RecvHandler : public Handler {
public:
	RecvHandler(Baseband* lm) : lm_(lm) {}
	void handle(Event* e);
	Baseband* lm_;
};

// simulates propagation delay
class TxHandler : public Handler {
public:
	TxHandler(Baseband* lm) : lm_(lm) {}
	void handle(Event* e);
	Baseband* lm_;
};

// Changes TDD state to IDLE (not used in this version)
class TDDHandler : public Handler {
public:
	TDDHandler(Baseband* lm) : lm_(lm) {}
	void handle(Event* e);
	Baseband* lm_;
};

// Used for collision detection (not used in this version)
class InterfererHandler: public Handler {
public:
	InterfererHandler(Baseband* lm) : lm_(lm) {}
	void handle(Event* e);
	Baseband* lm_;
};

class LMP;
class BTHost;

/*****************************************************************
 * The Baseband Class:
 * This class controls the trasmitting/receiving of packets
 * and implements most of the baseband functionality 
 * of the simulator: 
 * (1) State machine of the link controller. Bluetooth Specs v1.0A page 98
 * (2) Frequency hopping kernel. 
 * (3) Inquiry and paging procedures as in Bluetooth Specs.
 * (4) Location dependent error model
 * (5) Some HCI commands
 ****************************************************************/


class Baseband : public BiConnector {

	/* Handler classes */
	friend class CLKNHandler;		
	friend class CLKHandler;		 
	friend class RecvHandler;
	friend class TxHandler;
	friend class InterfererHandler;
	friend class TDDHandler;

	/* Addresses and access codes */
	int 	bd_addr_;
	int 	master_addr_;
	int 	giac_;
	int 	dac_;
	int 	page_addr_;

	vector<FHS_payload *> 	addr_vec_;
	uchar	active_list_[8];

	/* Clocks: native, master's, frozen and estimate */	
	long 	clkn_; 
	long	clk_; 
	long	clkf_; 
	long	clke_;

	/* Transmission timer */
	int 	txTimer_;

	/* Timers/counters related to inquiry/inquiry scan */
	long 	inqTimer_;
	long 	inqscanTimer_;
	long 	inqbackoffTimer_;
	long 	inqrespTimer_;
	int	Nfhs_;
	int 	numResponses_;

	/* Timers/counters related to page/page scan */
	long 	pageTimer_;
	long 	pagescanTimer_;
	long 	pagerespTimer_;
	long 	newConnectionTimer_;
	int 	Nmr_; 
	int	Nsr_;
	uchar 	Nsr_incr_offset_;
	int  	lastPaged_;

	/* Common variables for page and inquiry */
	int 		numId_; 
	int		numTrainsSent_;
	train_type      trainType_;
	uchar 		freeze_;


	/* State Variables */
	state_type      state_, prev_state_;
	tdd_state_type  tddState_;
	uchar		polled_;
	
	LMP** 		linkq_;

	/* Pointer to instance of Bluetooth Host (used for HCI exchanges) */
	BTHost* 	bthost_;

	/* Queue of connection requests */
	queue<ConnectionRequest*>* requestQ_;			// Check

	/* Collision detection and other receiver variables */
	PacketQueue* 	interfererQ_;
	PacketQueue* 	potinterfererQ_;

	double 		recv_start_;
	int 		recv_freq_;

	/* Simulation Events */
	Event 		clkn_ev_;		
	Event 		clk_ev_;		
	Event 		req_ev_;		
	Event 		tdd_ev_;		

	CLKNHandler		clkn_handler_;		
	CLKHandler		clk_handler_; 
	RecvHandler		recv_handler_;
	InterfererHandler	int_recv_handler_;
	TxHandler 		tx_handler_;
	TDDHandler 		tdd_handler_;

	static int 		firsttime_;
	int 			namTrace_;
	
	int 	seed_;
	int 	masterIndex_;
	int 	isOffset_;
	double	xpos_;
	double  ypos_;
	double  interArrival_;
	uchar 	am_addr_;
	uchar 	new_am_addr_;
	int 	numACLlinks_;

	/* Identifies currently used clock ie, CLK or CLKN */
	clock_type tx_clock_;
public:
	Baseband();
	void 	sendUp (Packet* p, Handler* h);
	int 	command (int, const char*const* );
	int 	recv_filter (Packet*);

	double 	calcLossProb (bt_packet_type, double); 
	void 	getAM_ADDR();
	void 	sendIDPacket(int);
	void 	sendFHSPacket();
	void 	sendPOLLPacket(uchar);
	void 	sendNULLPacket(uchar);
	void 	sendPacket (Packet* p);
	void 	sendHCI_Inquiry_Result(){}
	void 	sendPageResult() {}
	void 	sendPageSuccess(int) {}
	void 	sendPollResponse() {}
	void 	handleInqRespTO();

	void	start();
	Packet* 	schedule_next() {}

	//	HCI_commands
	void 	HCI_Inquiry (long, int);
	void	HCI_Create_Connection (int, int);

	
	void 	updateInqPageParam();
	void 	initInqPageParam();
	void 	changeState(state_type);
	uchar 	FH_kernel(int CLK, int CLK_frozen, FH_sequence_type FH_seq_type_t,
                int BD_addr); 
	uchar 	ADD_mod32(uchar ip1, uchar ip2);
	uchar 	EXOR_5(uchar ip1, uchar ip2);
	uchar 	EXOR_9(uint ip1, uint ip2);
	uchar 	PERM(uchar ip1, uchar ip2, uint ip3);
	uchar 	ADD_mod79(uchar ip1, uchar ip2, uchar ip3, uchar ip4);
	void  	BFLY(uchar ctrl, uchar& ip1, uchar& ip2);
};

/*==============================================================
			MAC SCHEDULING MODULE
==============================================================*/

//***********************Helper classes*************************
class BT_DRRScheduler; 

class PollHandler : public Handler {
public:
	PollHandler(BT_DRRScheduler* sched) : sched_(sched) {}
	void handle(Event* e);
	BT_DRRScheduler* sched_;
};

class PollEvent : public Event {
public: 
	PollEvent():Event() {}
	int	num_;
};

/****************************************************************
			SCHEDULER CLASS
****************************************************************/
class BT_DRRScheduler : public BiConnector {
	friend class PollHandler;
	double 	rate_[MaxQueues];
	uchar 	tos_[MaxQueues];
	int 	dc_[MaxQueues];
	uchar 	incr_[MaxQueues];
	int	backlog_fwd_[MaxQueues];
	int	backlog_rev_[MaxQueues];
	uchar 	active_[MaxQueues];
	int 	quanta_[MaxQueues];
	uchar 	maxPollInterval_[MaxQueues];
	uchar 	nextround_;

	PollEvent**	pollEvent_;

	double	cycleTime_;
	//double 	serviceRate_;
	double  slotsPerCycle_;
	double 	totalRate_;
	int 	totalQuanta_;

	PacketQueue* pollQ_;
	NsObject** lc_;
	
	uchar 	currQueue_;
	uchar 	numFlows_;
	PollHandler	ph_;

	// ############## QOS ###################
	QoSsupport* FPQ;
public:
	BT_DRRScheduler ();
	int 	command(int, const char*const*);
	uchar	updateQuanta (uchar, int, bt_packet_type);	
	uchar   mapQoS(uchar, flowSpec*, con_attr*);
	
	uchar	DRR_nextActive();

	Packet* schedule_next();
	Packet* DRR_schedule_next();
	Packet* FPQ_schedule_next();
	
	void	sendUp (Packet*, Handler*);	
	void	DRR_sendUp (Packet*, Handler*);	
	void	FPQ_sendUp (Packet*, Handler*);	
	
	void 	schedulePoll(int);
	Packet* createPOLLpacket(uchar);

	void    QOS_init(char nb_slav_ , int Time_begi_ , double alph_ );
	void    QOS_calc();

};

/*================================================================
			ARQ MODULE
================================================================*/

/*****************************************************************
	LINK CONTROLLER CLASS: Bluetooth Spec v1.0A pp 81
*****************************************************************/
class LinkController : public BiConnector {
	int 	tx_cnt_;
	int 	tx_thresh_;

	unsigned char 	seq_, ack_, seq_old_;
	
	int 		am_addr_; 
	unsigned char 		firsttime_;

 public: 
	Packet* 	curr_reg_;
	Packet* 	next_reg_;

 public:
	LinkController();

	void sendDown (Packet* p, Handler* h);
	void sendUp (Packet* p, Handler* h);
	Packet* send();
	int  pktSize();
	void compose_pkt (Packet* p);
	void switch_reg();
	void flush_payload();
	void initialize();
	void recvACK();
};


class L2CAP : public BiConnector {

	int 	cid_; 
	int 	identifier_;
	uchar	callback_[7];
	bt_packet_type 	packetType_[7];
	list<CID_attr*>*	cid_list_vec_;	
	queue<WriteReq*>*	write_reqQ_;

public:
	L2CAP();
	void 		L2CA_ConnectReq (uchar psm, uchar connection_handle, bt_packet_type);
	void 		sendUp (Packet* p, Handler* h); 
	void		dataWrite (Packet* p, uchar lcid);
	void 		callback(uchar ch);
	void 		L2CA_ConnectRsp (CID_attr* cid, uchar result);
	void		sendL2CAP_ConnectRequest (int ch, uchar scid, uchar id, uchar psm);
	void		sendL2CAP_ConnectRsp (CID_attr* cid, uchar result);
	bt_packet_type 	getPacketType (Packet*, uchar);
	CID_attr*	findCID (uchar cid, uchar connection_handle);
	CID_attr*	findCID (uchar cid);
};

/*====================================================================
			LEAKY BUCKET MODULE
====================================================================*/

//***********************Helper Classes*******************************
class LBF;

class SendHandler : public Handler {
public:
	SendHandler(LBF* lbf) : lbf_(lbf) {}
	void handle(Event* e);
	LBF* lbf_;
};

class TokenHandler : public Handler {
public:
	TokenHandler(LBF* lbf) : lbf_(lbf) {}
	void handle(Event* e);
	LBF* lbf_;
};

/*******************************************************************
			LEAKY BUCKET FILTER
*******************************************************************/
class LBF : public BiConnector {
	friend class SendHandler;
	friend class TokenHandler;
	int firsttime_;
	void updatetokens();
	double tokens_; 
	double tokenRate_; 
	int bucket_; 
	int qlength_;
	int conn_handle_;
	double peak_bw_;
	double lastupdate_;
	PacketQueue *inputQ_;
	PacketQueue *blockedQ_;
	Event send_ev_;
	SendHandler sh_;
	TokenHandler th_;
public:
	LBF();
	void release();
	void setParameters(flowSpec*);
	void recv(Packet *, Handler *);
};

/*==================================================================
		LINK MANAGER PROTOCOL MODULE
==================================================================*/

class LMP : public BiConnector {
	PacketQueue* 		l2capq_;
	PacketQueue* 		lmpq_;
	BT_DRRScheduler*   	sched_;
	BTHost* 		bthost_;
	//LBF*			tbf_;
	uchar 			am_addr_;
	uchar			packetType_;
	uchar			pollInterval_;
	uchar 			callback_;
	con_attr 		qoslm_;
	int			master_;
public:
	LBF*			tbf_;

public:
	LMP();
	int 	command(int argc, const char*const* argv);
	void	HCI_QoS_Setup (flowSpec*); 
	void	HCI_change_connection_packet_type (uchar);
	void    HCI_accept_connection_request();
	void 	callback();
	void 	sendDown(Packet*, Handler*);
	void 	sendUp(Packet*, Handler*);
	void 	sendLMPCommand(uchar, uchar);
};

struct HL_proto {
	NsObject* 	uptarget_;
	uchar		arp_table_[256];
	uchar 		cid;			
	uchar		value;
};		

/*=============================================================
			BTHOST MODULE
=============================================================*/


class BTHost : public Connector {

	// bind variables
	int inqTimeout_;
	int numResponses_;
	int bd_addr_;
	uchar master_;
	
	int numInqResp_;
	int numPaged_;
	int numConnections_;
	int currPaged_;
	int numApps_;

	// pointers to other simulation objects

	Baseband* 	lm_;
	L2CAP*	     	l2cap_;
	NsObject**   	trafgen_;    
	LMP**   	linkq_;    

	// structures required for multiplexing protocols over L2CAP
	HL_proto	proto1_;
	HL_proto	proto2_;

	vector<FHS_payload*>	vec_addr_;
	int 		active_addr_[7];
	bt_packet_type  type_[7];
	int		slave_am_addr_;
	string		appNames_[7];
	flowSpec**	appFlowSpec_;
	

public:
	BTHost();
	int  command(int, const char*const*); 

	// HCI Events
	void HCI_Inquiry_Result (vector<FHS_payload*>&);
	void HCI_Connection_Complete_Event (char);
	void sendHCICreateConnection();
	void HCI_QoS_Setup_Complete_Event(char, bt_packet_type);
	void HCI_ConnectionRequestEvent(uchar);	
	
	// L2CA Actions
	void L2CA_ConnectCfm (int, uchar, uchar);	
	void L2CA_ConnectInd (CID_attr*, uchar);

	void recv(Packet*, Handler*); 	
	void dataRead (Packet*, CID_attr*);
	void findAppNames();
};

#endif



