
/**************************************************************************************************
*IBM Public License Version 1.0 
*
*THE ACCOMPANYING PROGRAM IS PROVIDED UNDER THE TERMS OF THIS IBM PUBLIC LICENSE ("AGREEMENT"). ANY USE, REPRODUCTION OR DISTRIBUTION OF THE PROGRAM CONSTITUTES RECIPIENT'S ACCEPTANCE OF THIS AGREEMENT. 
*
*1. DEFINITIONS 
*
*"Contribution" means: 
*
*       a) in the case of International Business Machines Corporation ("IBM"), the Original Program, and 
*
*       b) in the case of each Contributor, 
*
*       i) changes to the Program, and
*
*       ii) additions to the Program;
*
*       where such changes and/or additions to the Program originate from and are distributed by that particular Contributor. A Contribution 'originates' from a Contributor if it
*       was added to the Program by such Contributor itself or anyone acting on such Contributor's behalf. Contributions do not include additions to the Program which: (i) are
*       separate modules of software distributed in conjunction with the Program under their own license agreement, and (ii) are not derivative works of the Program.
*
*  "Contributor" means IBM and any other entity that distributes the Program. 
*
*  "Licensed Patents " mean patent claims licensable by a Contributor which are necessarily infringed by the use or sale of its Contribution alone or when combined with the
*  Program. 
*
*  "Original Program" means the original version of the software accompanying this Agreement as released by IBM, including source code, object code and documentation, if
*  any. 
*
*  "Program" means the Original Program and Contributions. 
*
*  "Recipient" means anyone who receives the Program under this Agreement, including all Contributors. 
*
*  2. GRANT OF RIGHTS 
*
*       a) Subject to the terms of this Agreement, each Contributor hereby grants Recipient a non-exclusive, worldwide, royalty-free copyright license to reproduce, prepare
*       derivative works of, publicly display, publicly perform, distribute and sublicense the Contribution of such Contributor, if any, and such derivative works, in source code
*       and object code form.
*
*       b) Subject to the terms of this Agreement, each Contributor hereby grants Recipient a non-exclusive, worldwide, royalty-free patent license under Licensed Patents to
*       make, use, sell, offer to sell, import and otherwise transfer the Contribution of such Contributor, if any, in source code and object code form. This patent license shall
*       apply to the combination of the Contribution and the Program if, at the time the Contribution is added by the Contributor, such addition of the Contribution causes
*       such combination to be covered by the Licensed Patents. The patent license shall not apply to any other combinations which include the Contribution. No hardware per
*       se is licensed hereunder. 
*
*       c) Recipient understands that although each Contributor grants the licenses to its Contributions set forth herein, no assurances are provided by any Contributor that
*       the Program does not infringe the patent or other intellectual property rights of any other entity. Each Contributor disclaims any liability to Recipient for claims brought
*       by any other entity based on infringement of intellectual property rights or otherwise. As a condition to exercising the rights and licenses granted hereunder, each
*       Recipient hereby assumes sole responsibility to secure any other intellectual property rights needed, if any. For example, if a third party patent license is required to
*       allow Recipient to distribute the Program, it is Recipient's responsibility to acquire that license before distributing the Program.
*
*       d) Each Contributor represents that to its knowledge it has sufficient copyright rights in its Contribution, if any, to grant the copyright license set forth in this
*       Agreement. 
*
*  3. REQUIREMENTS 
*
*  A Contributor may choose to distribute the Program in object code form under its own license agreement, provided that: 
*
*       a) it complies with the terms and conditions of this Agreement; and
*
*       b) its license agreement:
*
*       i) effectively disclaims on behalf of all Contributors all warranties and conditions, express and implied, including warranties or conditions of title and non-infringement,
*       and implied warranties or conditions of merchantability and fitness for a particular purpose; 
*
*       ii) effectively excludes on behalf of all Contributors all liability for damages, including direct, indirect, special, incidental and consequential damages, such as lost
*       profits; 
*
*       iii) states that any provisions which differ from this Agreement are offered by that Contributor alone and not by any other party; and
*
*       iv) states that source code for the Program is available from such Contributor, and informs licensees how to obtain it in a reasonable manner on or through a medium
*       customarily used for software exchange. 
*
*  When the Program is made available in source code form: 
*
*       a) it must be made available under this Agreement; and 
*
*       b) a copy of this Agreement must be included with each copy of the Program. 
*
*  Each Contributor must include the following in a conspicuous location in the Program: 
*
*       Copyright  {date here}, International Business Machines Corporation and others. All Rights Reserved. 
*
*  In addition, each Contributor must identify itself as the originator of its Contribution, if any, in a manner that reasonably allows subsequent Recipients to identify the originator
*  of the Contribution. 
*
*  4. COMMERCIAL DISTRIBUTION 
*
*  Commercial distributors of software may accept certain responsibilities with respect to end users, business partners and the like. While this license is intended to facilitate the
*  commercial use of the Program, the Contributor who includes the Program in a commercial product offering should do so in a manner which does not create potential liability
*  for other Contributors. Therefore, if a Contributor includes the Program in a commercial product offering, such Contributor ("Commercial Contributor") hereby agrees to defend
*  and indemnify every other Contributor ("Indemnified Contributor") against any losses, damages and costs (collectively "Losses") arising from claims, lawsuits and other legal
*  actions brought by a third party against the Indemnified Contributor to the extent caused by the acts or omissions of such Commercial Contributor in connection with its
*  distribution of the Program in a commercial product offering. The obligations in this section do not apply to any claims or Losses relating to any actual or alleged intellectual
*  property infringement. In order to qualify, an Indemnified Contributor must: a) promptly notify the Commercial Contributor in writing of such claim, and b) allow the Commercial
*  Contributor to control, and cooperate with the Commercial Contributor in, the defense and any related settlement negotiations. The Indemnified Contributor may participate in
*  any such claim at its own expense. 
*
*  For example, a Contributor might include the Program in a commercial product offering, Product X. That Contributor is then a Commercial Contributor. If that Commercial
*  Contributor then makes performance claims, or offers warranties related to Product X, those performance claims and warranties are such Commercial Contributor's
*  responsibility alone. Under this section, the Commercial Contributor would have to defend claims against the other Contributors related to those performance claims and
*  warranties, and if a court requires any other Contributor to pay any damages as a result, the Commercial Contributor must pay those damages. 
*
*  5. NO WARRANTY 
*
*  EXCEPT AS EXPRESSLY SET FORTH IN THIS AGREEMENT, THE PROGRAM IS PROVIDED ON AN "AS IS" BASIS, WITHOUT WARRANTIES OR CONDITIONS OF ANY
*  KIND, EITHER EXPRESS OR IMPLIED INCLUDING, WITHOUT LIMITATION, ANY WARRANTIES OR CONDITIONS OF TITLE, NON-INFRINGEMENT,
*  MERCHANTABILITY OR FITNESS FOR A PARTICULAR PURPOSE. Each Recipient is solely responsible for determining the appropriateness of using and distributing the
*  Program and assumes all risks associated with its exercise of rights under this Agreement, including but not limited to the risks and costs of program errors, compliance with
*  applicable laws, damage to or loss of data, programs or equipment, and unavailability or interruption of operations. 
*
*  6. DISCLAIMER OF LIABILITY 
*
*  EXCEPT AS EXPRESSLY SET FORTH IN THIS AGREEMENT, NEITHER RECIPIENT NOR ANY CONTRIBUTORS SHALL HAVE ANY LIABILITY FOR ANY DIRECT,
*  INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING WITHOUT LIMITATION LOST PROFITS), HOWEVER CAUSED AND
*  ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT
*  OF THE USE OR DISTRIBUTION OF THE PROGRAM OR THE EXERCISE OF ANY RIGHTS GRANTED HEREUNDER, EVEN IF ADVISED OF THE POSSIBILITY OF
*  SUCH DAMAGES. 
*
*  7. GENERAL 
*
*  If any provision of this Agreement is invalid or unenforceable under applicable law, it shall not affect the validity or enforceability of the remainder of the terms of this
*  Agreement, and without further action by the parties hereto, such provision shall be reformed to the minimum extent necessary to make such provision valid and enforceable. 
*
*  If Recipient institutes patent litigation against a Contributor with respect to a patent applicable to software (including a cross-claim or counterclaim in a lawsuit), then any
*  patent licenses granted by that Contributor to such Recipient under this Agreement shall terminate as of the date such litigation is filed. In addition, If Recipient institutes
*  patent litigation against any entity (including a cross-claim or counterclaim in a lawsuit) alleging that the Program itself (excluding combinations of the Program with other
*  software or hardware) infringes such Recipient's patent(s), then such Recipient's rights granted under Section 2(b) shall terminate as of the date such litigation is filed. 
*
*  All Recipient's rights under this Agreement shall terminate if it fails to comply with any of the material terms or conditions of this Agreement and does not cure such failure in a
*  reasonable period of time after becoming aware of such noncompliance. If all Recipient's rights under this Agreement terminate, Recipient agrees to cease use and
*  distribution of the Program as soon as reasonably practicable. However, Recipient's obligations under this Agreement and any licenses granted by Recipient relating to the
*  Program shall continue and survive. 
*
*  IBM may publish new versions (including revisions) of this Agreement from time to time. Each new version of the Agreement will be given a distinguishing version number. The
*  Program (including Contributions) may always be distributed subject to the version of the Agreement under which it was received. In addition, after a new version of the
*  Agreement is published, Contributor may elect to distribute the Program (including its Contributions) under the new version. No one other than IBM has the right to modify this
*  Agreement. Except as expressly stated in Sections 2(a) and 2(b) above, Recipient receives no rights or licenses to the intellectual property of any Contributor under this
*  Agreement, whether expressly, by implication, estoppel or otherwise. All rights in the Program not expressly granted under this Agreement are reserved. 
*
*  This Agreement is governed by the laws of the State of New York and the intellectual property laws of the United States of America. No party to this Agreement will bring a
*  legal action under this Agreement more than one year after the cause of action arose. Each party waives its rights to a jury trial in any resulting litigation. 
**********************************************************************************************************************/
#ifndef bt_def_h
#define bt_def_h
#include "packet.h"

//#define BT_NULL 	0x00
//#define BT_POLL 	0x01
//#define BT_FHS	 	0x02
//#define BT_DM1	 	0x03
//#define BT_DH1	 	0x04
//#define BT_HV1	 	0x05
//#define BT_HV2	 	0x06
//#define BT_HV3	 	0x07
//#define BT_DV	 	0x08
//#define BT_AUX1	 	0x09
//#define BT_DM3	 	0x0A
//#define BT_DH3	 	0x0B
//#define BT_DM5	 	0x0E
//#define BT_DH5	 	0x0F
//#define BT_ID	 	0x1F		// Change

#define MIN(a,b) ((a) < (b)) ? (a) : (b)
	
typedef unsigned char uchar;
typedef unsigned short ushort;
typedef struct l2_cmd {
	uchar 	code;
	uchar 	identifier;
	uchar	length;
} L2cmd;

typedef enum {
	OPEN, CLOSED, W4_L2CAP_ConnectRsp, W4_L2CA_ConnectRsp
} L2CAP_state;

typedef enum {
	BT_NULL, BT_POLL, BT_FHS, BT_DM1, BT_DH1, BT_HV1, BT_HV2, BT_HV3, BT_DV, BT_AUX1, 
	BT_DM3, BT_DH3, BT_DM5 = 0x0e, BT_DH5, BT_ID
} bt_packet_type;

struct hdr_l2cap {
	ushort 	length;
	ushort 	cid;
	L2cmd	cmd;
	static int 		offset_;
	inline static int& 	offset() { return offset_; }
	inline static hdr_l2cap* access(Packet* p) {
		return (hdr_l2cap*)p->access(offset_);
	}
};

struct CID_attr {
	uchar 	lcid; 
	uchar 	rcid;
	uchar 	ch;
	uchar 	psm;
	int 	length; 
	int 	total_length;
	int 	identifier;
	Packet* 	packet;
	L2CAP_state	state;
	CID_attr() {
		lcid = rcid = ch = psm = length = total_length = 0;
		packet = 0; 
		state = CLOSED;
	}
};

struct flowSpec {
	int 	mtu;
	int 	token_rate;	// multiples of kbps
	int 	token_bucket;   // bits
	int 	input_qlen;	// bits
	int 	peak_bw;	// multiples of kbps
	int  	latency;	// multiples of msec
	int	loss_sensitivity; 
};
	
struct con_attr {
	bt_packet_type	packet_type;
	uchar 	polling_interval;
};
		
struct WriteReq {
	Packet* pkt;
	uchar	cid;
};

typedef enum {
	page_hopping,
  	page_scan,
  	slave_response,
 	master_response,
  	inquiry_hopping,
  	inquiry_scan,
  	inquiry_response,
  	channel_hopping
} FH_sequence_type;

typedef enum {
	STANDBY, 
	NEW_CONNECTION,
	CONNECTION,
	PAGE, 
	PAGE_SCAN,
	SLAVE_RESP,
	SLAVE_RESP_ID_SENT,
	MASTER_RESP,
	INQUIRY, 
	INQ_SCAN, 
	INQ_RESP
} state_type;

typedef enum {
	TRANSMIT, 
	LISTEN,
	RECEIVE, 
	IDLE
} tdd_state_type;

typedef enum {
	A, B 
} train_type;

typedef enum {
	CLKN, CLK
} clock_type;

struct access_code {
	uchar 		preamble : 4;
	uchar 		syncword[8];
	uchar 		trailer : 4;
};

typedef struct payload {
	uchar 		l_ch;
	uchar 		flow;
	unsigned int 	length;
	uchar*		data;
} BT_payload;

typedef struct fhspayload {
	int 	addr;
	int 	clock;
} FHS_payload;
	

struct hdr_bt {
	//struct access_code 	ac;
	uchar 		am_addr;
	bt_packet_type     type;
	uchar           flow;
	uchar           arqn;
	uchar           seqn;
	uchar           hec;
	struct payload 	ph;

	uchar 		dir;
	int 		recvId_;
	int 		sendId_;
	int		fs_;
	double 		xpos_; 
	double 		ypos_;
		
	static int 		offset_;
	inline static int& 	offset() { return offset_; }
	inline static hdr_bt* 	access(Packet* p) {
		return (hdr_bt*)p->access(offset_);
	}
};

#endif



// ############### Rajout QOS ###########################

struct QoSsupport {
  // Struct for FPQ and PFP 

  uchar nb_slave;
  int Time_begin;              // in secondes: the time at which the DRR ends and FPQ starts  
  float Time_slot;             // in microsecondes: time length of a slot
  double alpha;                // Parameter OF FPQ
  

  // QoS Requests
  float FR_s[7];               // Flow Rate request for upstream traffic (ITP in ms) 
  float FR_m[7];               // Flow Rate request for downstream traffic (ITP in ms) 
  int MD_s[7];                 // Max. Delay Request for upstream traffic (in Nb of slots -> 160 <-> 100 ms)
  int MD_m[7];                 // Max. Delay Request for downstream traffic (in Nb of slots -> 160 <-> 100 ms)            
   

  
  // Probability of data : upstream traffic
  int N_proba[7];              // nb of the iteration : corresponds to n from Tn
  double P_geq_one_n[7];       // P (Buffer >=1 at Tn )
  double P_gre_one_n[7];       // P (Buffer >1 at Tn )
  double P_eq_one_n[7];        // P (Buffer =1 at Tn )
  double T_0[7];               // Last Poll with a NULL packet sent back : correspond to T0
  double T_n[7];               // Max(Last successfull Poll, T_0) : corresponds to Tn
  char begin_packet_s[7];      // Boolean to know if the next Baseband packet will be the fisrt segment of a L2CAP packet
  int ITLN[7];                 //Interval of Time since Last Null packet -> for MD support

  double Pdata_s[7];    
  
  // Probability of data : downstream traffic
  char begin_packet_m[7];      // Boolean to know if the next Baseband packet will be the fisrt segment of a L2CAP packet
  int ITQE[7];                 // Interval of Time since Last Null packet -> for MD support

  double Pdata_m[7];    
  
  double Pdata[7];


  // NSLP.....
  int Ns[7];
  int Nm[7];
  
  int N_sm[7];
  double Pr[7];                // Priority of each slave...


};





//struct Pbetqos {

//uchar nb_slave;
//char currentslave;      // The slave which has begun the transmission of a packet
//int Time_begin;         // in secondes
//float Time_slot;        // in microsecondes
//double alpha;           // Parameter from the decision model
//char Try;               // Decides which version of QOS polling scheme should be used
//char UseTD;             // Decides which TD must be used
  
//int nbslot_wait[7];
//int nbslot_wait_master[7];


//int TOut_req[7];           // Nb of slot for the max. delay requested
//int nbslot_TOut[7];        // Nb of slot since the last missed poll

//int TOut_req_master[7];    // Nb of slot for the max. delay requested
//int nbslot_TOut_master[7]; // Nb of slot since the last missed poll


//double T_firstgood[7];  // First successfull Poll (beginnig of a packet !!!!) of the serie
//double Nb_int[7];       // Nb of intervalles         
//float TD[7];            // The mean value of TD_appli and TD_estimated
//float TD_appli[7];      // given by the application
//float TD_estimated[7];  // estimation of TD by the MAC Scheduler
//
//float qr[7];           // given by the application
//int nb_polls[7];       // reciprocal of qti..
  
//char begin_packet[7];  // Boolean to know if it will be a new L2CAP packet or the continuationof a L2CAP packet
  
//char begin_packet_master[7];   // for traffic from master to slave
//int nb_slot_begin_packet[7];  // nb of slots since the beginning of the transmission of a new packet (-> to calculate Pdata...)

//int Nb_beenpolled[7];          // nb of the iteration : corresponds to n from Tn
//double P_supequal_one_n[7];    // P (Buffer >=1 at Tn )
//double P_sup_one_n[7];         // P (Buffer >1 at Tn )
//double P_equal_one_n[7];       // P (Buffer =1 at Tn )
//double T_first_poll[7];        // Last Poll who fails
//double T_last_poll[7];         // Max (Last successfull Poll T_first_poll)

  
//double Pdata_master[7];    
//double Pdata_slave[7];    
//double Pdata[7];
//  
//double sum_Pdata;
//double fqt[7];
//double Ffqt[7];
  
//double U[7];

//};

