
/**************************************************************************************************
*IBM Public License Version 1.0 
*
*THE ACCOMPANYING PROGRAM IS PROVIDED UNDER THE TERMS OF THIS IBM PUBLIC LICENSE ("AGREEMENT"). ANY USE, REPRODUCTION OR DISTRIBUTION OF THE PROGRAM CONSTITUTES RECIPIENT'S ACCEPTANCE OF THIS AGREEMENT. 
*
*1. DEFINITIONS 
*
*"Contribution" means: 
*
*       a) in the case of International Business Machines Corporation ("IBM"), the Original Program, and 
*
*       b) in the case of each Contributor, 
*
*       i) changes to the Program, and
*
*       ii) additions to the Program;
*
*       where such changes and/or additions to the Program originate from and are distributed by that particular Contributor. A Contribution 'originates' from a Contributor if it
*       was added to the Program by such Contributor itself or anyone acting on such Contributor's behalf. Contributions do not include additions to the Program which: (i) are
*       separate modules of software distributed in conjunction with the Program under their own license agreement, and (ii) are not derivative works of the Program.
*
*  "Contributor" means IBM and any other entity that distributes the Program. 
*
*  "Licensed Patents " mean patent claims licensable by a Contributor which are necessarily infringed by the use or sale of its Contribution alone or when combined with the
*  Program. 
*
*  "Original Program" means the original version of the software accompanying this Agreement as released by IBM, including source code, object code and documentation, if
*  any. 
*
*  "Program" means the Original Program and Contributions. 
*
*  "Recipient" means anyone who receives the Program under this Agreement, including all Contributors. 
*
*  2. GRANT OF RIGHTS 
*
*       a) Subject to the terms of this Agreement, each Contributor hereby grants Recipient a non-exclusive, worldwide, royalty-free copyright license to reproduce, prepare
*       derivative works of, publicly display, publicly perform, distribute and sublicense the Contribution of such Contributor, if any, and such derivative works, in source code
*       and object code form.
*
*       b) Subject to the terms of this Agreement, each Contributor hereby grants Recipient a non-exclusive, worldwide, royalty-free patent license under Licensed Patents to
*       make, use, sell, offer to sell, import and otherwise transfer the Contribution of such Contributor, if any, in source code and object code form. This patent license shall
*       apply to the combination of the Contribution and the Program if, at the time the Contribution is added by the Contributor, such addition of the Contribution causes
*       such combination to be covered by the Licensed Patents. The patent license shall not apply to any other combinations which include the Contribution. No hardware per
*       se is licensed hereunder. 
*
*       c) Recipient understands that although each Contributor grants the licenses to its Contributions set forth herein, no assurances are provided by any Contributor that
*       the Program does not infringe the patent or other intellectual property rights of any other entity. Each Contributor disclaims any liability to Recipient for claims brought
*       by any other entity based on infringement of intellectual property rights or otherwise. As a condition to exercising the rights and licenses granted hereunder, each
*       Recipient hereby assumes sole responsibility to secure any other intellectual property rights needed, if any. For example, if a third party patent license is required to
*       allow Recipient to distribute the Program, it is Recipient's responsibility to acquire that license before distributing the Program.
*
*       d) Each Contributor represents that to its knowledge it has sufficient copyright rights in its Contribution, if any, to grant the copyright license set forth in this
*       Agreement. 
*
*  3. REQUIREMENTS 
*
*  A Contributor may choose to distribute the Program in object code form under its own license agreement, provided that: 
*
*       a) it complies with the terms and conditions of this Agreement; and
*
*       b) its license agreement:
*
*       i) effectively disclaims on behalf of all Contributors all warranties and conditions, express and implied, including warranties or conditions of title and non-infringement,
*       and implied warranties or conditions of merchantability and fitness for a particular purpose; 
*
*       ii) effectively excludes on behalf of all Contributors all liability for damages, including direct, indirect, special, incidental and consequential damages, such as lost
*       profits; 
*
*       iii) states that any provisions which differ from this Agreement are offered by that Contributor alone and not by any other party; and
*
*       iv) states that source code for the Program is available from such Contributor, and informs licensees how to obtain it in a reasonable manner on or through a medium
*       customarily used for software exchange. 
*
*  When the Program is made available in source code form: 
*
*       a) it must be made available under this Agreement; and 
*
*       b) a copy of this Agreement must be included with each copy of the Program. 
*
*  Each Contributor must include the following in a conspicuous location in the Program: 
*
*       Copyright  {date here}, International Business Machines Corporation and others. All Rights Reserved. 
*
*  In addition, each Contributor must identify itself as the originator of its Contribution, if any, in a manner that reasonably allows subsequent Recipients to identify the originator
*  of the Contribution. 
*
*  4. COMMERCIAL DISTRIBUTION 
*
*  Commercial distributors of software may accept certain responsibilities with respect to end users, business partners and the like. While this license is intended to facilitate the
*  commercial use of the Program, the Contributor who includes the Program in a commercial product offering should do so in a manner which does not create potential liability
*  for other Contributors. Therefore, if a Contributor includes the Program in a commercial product offering, such Contributor ("Commercial Contributor") hereby agrees to defend
*  and indemnify every other Contributor ("Indemnified Contributor") against any losses, damages and costs (collectively "Losses") arising from claims, lawsuits and other legal
*  actions brought by a third party against the Indemnified Contributor to the extent caused by the acts or omissions of such Commercial Contributor in connection with its
*  distribution of the Program in a commercial product offering. The obligations in this section do not apply to any claims or Losses relating to any actual or alleged intellectual
*  property infringement. In order to qualify, an Indemnified Contributor must: a) promptly notify the Commercial Contributor in writing of such claim, and b) allow the Commercial
*  Contributor to control, and cooperate with the Commercial Contributor in, the defense and any related settlement negotiations. The Indemnified Contributor may participate in
*  any such claim at its own expense. 
*
*  For example, a Contributor might include the Program in a commercial product offering, Product X. That Contributor is then a Commercial Contributor. If that Commercial
*  Contributor then makes performance claims, or offers warranties related to Product X, those performance claims and warranties are such Commercial Contributor's
*  responsibility alone. Under this section, the Commercial Contributor would have to defend claims against the other Contributors related to those performance claims and
*  warranties, and if a court requires any other Contributor to pay any damages as a result, the Commercial Contributor must pay those damages. 
*
*  5. NO WARRANTY 
*
*  EXCEPT AS EXPRESSLY SET FORTH IN THIS AGREEMENT, THE PROGRAM IS PROVIDED ON AN "AS IS" BASIS, WITHOUT WARRANTIES OR CONDITIONS OF ANY
*  KIND, EITHER EXPRESS OR IMPLIED INCLUDING, WITHOUT LIMITATION, ANY WARRANTIES OR CONDITIONS OF TITLE, NON-INFRINGEMENT,
*  MERCHANTABILITY OR FITNESS FOR A PARTICULAR PURPOSE. Each Recipient is solely responsible for determining the appropriateness of using and distributing the
*  Program and assumes all risks associated with its exercise of rights under this Agreement, including but not limited to the risks and costs of program errors, compliance with
*  applicable laws, damage to or loss of data, programs or equipment, and unavailability or interruption of operations. 
*
*  6. DISCLAIMER OF LIABILITY 
*
*  EXCEPT AS EXPRESSLY SET FORTH IN THIS AGREEMENT, NEITHER RECIPIENT NOR ANY CONTRIBUTORS SHALL HAVE ANY LIABILITY FOR ANY DIRECT,
*  INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING WITHOUT LIMITATION LOST PROFITS), HOWEVER CAUSED AND
*  ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT
*  OF THE USE OR DISTRIBUTION OF THE PROGRAM OR THE EXERCISE OF ANY RIGHTS GRANTED HEREUNDER, EVEN IF ADVISED OF THE POSSIBILITY OF
*  SUCH DAMAGES. 
*
*  7. GENERAL 
*
*  If any provision of this Agreement is invalid or unenforceable under applicable law, it shall not affect the validity or enforceability of the remainder of the terms of this
*  Agreement, and without further action by the parties hereto, such provision shall be reformed to the minimum extent necessary to make such provision valid and enforceable. 
*
*  If Recipient institutes patent litigation against a Contributor with respect to a patent applicable to software (including a cross-claim or counterclaim in a lawsuit), then any
*  patent licenses granted by that Contributor to such Recipient under this Agreement shall terminate as of the date such litigation is filed. In addition, If Recipient institutes
*  patent litigation against any entity (including a cross-claim or counterclaim in a lawsuit) alleging that the Program itself (excluding combinations of the Program with other
*  software or hardware) infringes such Recipient's patent(s), then such Recipient's rights granted under Section 2(b) shall terminate as of the date such litigation is filed. 
*
*  All Recipient's rights under this Agreement shall terminate if it fails to comply with any of the material terms or conditions of this Agreement and does not cure such failure in a
*  reasonable period of time after becoming aware of such noncompliance. If all Recipient's rights under this Agreement terminate, Recipient agrees to cease use and
*  distribution of the Program as soon as reasonably practicable. However, Recipient's obligations under this Agreement and any licenses granted by Recipient relating to the
*  Program shall continue and survive. 
*
*  IBM may publish new versions (including revisions) of this Agreement from time to time. Each new version of the Agreement will be given a distinguishing version number. The
*  Program (including Contributions) may always be distributed subject to the version of the Agreement under which it was received. In addition, after a new version of the
*  Agreement is published, Contributor may elect to distribute the Program (including its Contributions) under the new version. No one other than IBM has the right to modify this
*  Agreement. Except as expressly stated in Sections 2(a) and 2(b) above, Recipient receives no rights or licenses to the intellectual property of any Contributor under this
*  Agreement, whether expressly, by implication, estoppel or otherwise. All rights in the Program not expressly granted under this Agreement are reserved. 
*
*  This Agreement is governed by the laws of the State of New York and the intellectual property laws of the United States of America. No party to this Agreement will bring a
*  legal action under this Agreement more than one year after the cause of action arose. Each party waives its rights to a jury trial in any resulting litigation. 
**********************************************************************************************************************/
/* This class simulates the L2CAP SAR, protocol multiplexing and
signaling functions. Signaling is limited to sending and receiving 
connection request and response 
*/

#include "bt-core.h"
int hdr_l2cap::offset_;

static class L2CAPHeaderClass : public PacketHeaderClass {
public:
	L2CAPHeaderClass() : PacketHeaderClass("PacketHeader/L2CAP", sizeof(hdr_l2cap)) {
		bind_offset(&hdr_l2cap::offset_);
	}
} class_l2caphdr;

static class L2CAPClass : public TclClass 
{
public:
	L2CAPClass() : TclClass("L2CAP"){}
	TclObject* create( int, const char*const*) {
	 	return ( new L2CAP );
	}
} class_l2cap;

L2CAP::L2CAP() : cid_(1), identifier_(0)
{
	for (int i=0; i<7; i++) {
		callback_[i] = 0;
		packetType_[i] = BT_NULL;	
	}
	write_reqQ_ = new queue<WriteReq*>[7];
	cid_list_vec_  = new (list<CID_attr*>)[7];
}


// primitive for connection establishment
void
L2CAP::L2CA_ConnectReq (uchar psm, uchar connection_handle, bt_packet_type packet_type)
{
	cid_ = (cid_+1)%MaxCID;								      // initialize cid_ = 1
	packetType_[connection_handle] = packet_type;
	sendL2CAP_ConnectRequest(connection_handle, cid_, ++identifier_, psm);
}

// Receive a packet from the lower layer
void
L2CAP::sendUp (Packet* p, Handler* h)
{
        hdr_bt* bt = HDR_BT(p);
	hdr_cmn* ch = HDR_CMN(p);
	hdr_l2cap* l2cap = HDR_L2CAP(p);
	uchar connection_handle = bt->am_addr -1;
	uchar psm, rcid, scid, result; 
	uchar* data = p->accessdata();
	CID_attr* cid_attr;
	BTHost* bthost;

	Scheduler& s = Scheduler::instance();

	if (l2cap->cid == 0x01) {
		// Handle signaling packet
		L2cmd l2cmd = l2cap->cmd; 	
		switch (l2cmd.code) {
		    // Receive L2CAP_ConnectReq
		    case (0x02) : 
			printf("RECV L2CAP_CONNECT_REQ\t CH: %d\n", connection_handle);
			psm = data[0];
			rcid = data[1];
			cid_attr = new CID_attr();
			cid_attr->lcid = ++cid_;
			cid_attr->rcid = rcid;
			cid_attr->psm = psm;
			cid_attr->ch = connection_handle;
			cid_attr->state = W4_L2CA_ConnectRsp;
			cid_attr->identifier = l2cmd.identifier;
			bthost = (BTHost*)uptarget_;
			bthost->L2CA_ConnectInd(cid_attr, psm);
			break;

		    // Receive L2CAP_ConnectRsp
		    case (0x03) :
			printf("RECV L2CAP_CONNECT_RSP\t CH: %d\n", connection_handle);
			scid = data[0];
			rcid = data[1];
			result = data[2];
			cid_attr = findCID(scid, connection_handle);
			cid_attr->rcid = rcid;
			cid_attr->ch = connection_handle;
			cid_attr->state = OPEN;
			bthost = (BTHost*)uptarget_;
			bthost->L2CA_ConnectCfm(cid_attr->lcid, connection_handle, cid_attr->psm);
			break;
		    
		}
		Packet::free(p);
		return;
	}

	/* Data packet received */
	/* Find cid structure for the channel */
	CID_attr* cid = findCID(l2cap->cid, connection_handle);

	//invalid CID
	if (!cid) {
		Packet::free(p);
		return;
	}

	// valid CID
	// Start of new L2CAP packet
	if (bt->ph.l_ch == 0x0a) {
	   
	   if (cid->total_length) { 
		if (cid->packet)
		  Packet::free(cid->packet);
	   }
		cid->packet = p; 
		cid->length = l2cap->length;
		cid->total_length = ch->size() - 4;
	}
	// continuation of L2CAP packet
	else {
	        cid->total_length += ch->size();	
		Packet::free(p);
	}

	// L2CAP packet complete
	if (cid->total_length == cid->length) {
	        
	        hdr_ip* iph = HDR_IP(cid->packet);

		printf("L2CA_DATA_READ\t\tSIZE: %-10d\tCID: %d\t\tDEST_IP %d\t SRC_IP %d\t clock %e\n",cid->length, cid->lcid, iph->daddr() , iph->saddr(), s.clock());

		cid->length = 0;
		BTHost* bthost = (BTHost*)uptarget_;
		hdr_cmn* hdr = HDR_CMN(cid->packet);
		hdr->size() = cid->total_length;
		bthost->dataRead(cid->packet, cid);
		cid->packet = 0;
		cid->total_length = 0;
	}
}	
		
// Data Write primitive
void
L2CAP::dataWrite (Packet* p, uchar lcid)
{
        WriteReq* req = new WriteReq;
	CID_attr* cid = findCID(lcid);	
	uchar ch = cid->ch;
	req->cid = lcid;
	req->pkt = p;
	write_reqQ_[ch].push(req);
	if (callback_[ch]) {
		callback_[ch]=0;
		callback(ch);
	}
}

// segment and send L2CAP packet to lower layer
void
L2CAP::callback(uchar ch)
{
	if (write_reqQ_[ch].empty()) {
		callback_[ch] = 1;
		return;
	}
	WriteReq* wr = write_reqQ_[ch].front();
	write_reqQ_[ch].pop();
	Packet* p = wr->pkt;	
	Packet* pkt;
	int lcid = wr->cid;

	// Find cid struct for the given local CID

	hdr_cmn* hdr = HDR_CMN(p);
	CID_attr* cid = findCID(lcid);
	int rcid = cid->rcid;
		
	// Find L2CAP packet size
	int length = hdr->size();
	hdr->size() += L2capHdrSize;

	// Find number of segments
	bt_packet_type packet_type = getPacketType(p, ch);
	int packetsize = Payload[packet_type];			
	int num_fullseg = (hdr->size()/packetsize);
	int last_segsize = (hdr->size()%packetsize);
	int num_seg = (last_segsize) ? num_fullseg+1 : num_fullseg; 
	hdr_bt* bt;
	hdr_l2cap* l2cap;

	// Simulate Segmentation 
	for (int i=0; i < num_seg; i++) {
		if (i == 0) {
			pkt = p->copy();
			l2cap = HDR_L2CAP(pkt);
			l2cap->length = length;
			bt = HDR_BT(pkt);
			bt->ph.l_ch = 0x0a;
		}
		else {
			pkt = Packet::alloc();
			bt = HDR_BT(pkt);
			bt->ph.l_ch = 0x01;
		}
			
		l2cap = HDR_L2CAP(pkt);
		hdr_cmn* hdr = HDR_CMN(pkt);
		bt->am_addr = ch+1;
		l2cap->cid = rcid;
		if (i < num_fullseg) {
			hdr->size() = packetsize;		
			bt->type = packet_type;
		}
		else {
			hdr->size() = last_segsize;
			bt->type = getPacketType(pkt,ch);
		}
		downtarget_->recv(pkt, this);
	}	
	Packet::free(p);
	delete wr;
}	


// get the packet type to be used
bt_packet_type 
L2CAP::getPacketType(Packet* p, uchar ch)
{
	hdr_cmn* hdr = HDR_CMN(p);
	int size = hdr->size();
	uchar fec = 0; 
	// Get the largest packet type for the connection 
	bt_packet_type largest = (packetType_[ch]) ? packetType_[ch] : BT_DH5;
	bt_packet_type type;
	if (largest == BT_DM1 || largest == BT_DM3 || largest == BT_DM5)
		fec = 1;
	
	if (fec) {
		// FEC required
		if ((size > Payload[14]) || ((size <= Payload[14]) && (size > Payload[10])))
			type = BT_DM5;
		else if (size <= Payload[10] && size > Payload[3])
			type = BT_DM3;
		else 
			type = BT_DM1;
	}
	else {
		// No FEC
		if ((size > Payload[15]) || ((size <= Payload[15]) && (size > Payload[11])))
			type = BT_DH5;
		else if (size <= Payload[11] && size > Payload[4])
			type = BT_DH3;
		else 
			type = BT_DH1;
	}	
	type = (type > largest) ? largest: type;
		
	return type;
}


// Connect response primitive
void
L2CAP::L2CA_ConnectRsp (CID_attr* cid, uchar result)
{
	if (!result) {
		sendL2CAP_ConnectRsp (cid, 0x0004);
		delete cid;
	}
	else {
		cid->state = OPEN;
		cid_list_vec_[cid->ch].push_back(cid);
		sendL2CAP_ConnectRsp (cid, 0);
	}	
}

// create and send L2CAP_ConnectRequest
void 
L2CAP::sendL2CAP_ConnectRequest (int ch, uchar scid, uchar id, uchar psm)
{
	Packet* p = Packet::alloc(4);
	hdr_cmn* hdr = HDR_CMN(p);
	hdr_l2cap* l2cap = HDR_L2CAP(p);
	hdr_bt* bt = HDR_BT(p);
	bt->am_addr = ch+1;
	bt->ph.l_ch = 0x0a;
	bt->type = BT_DM1;
	L2cmd& l2cmd = l2cap->cmd; 	
	uchar* data = p->accessdata();

	CID_attr* cid_attr = new CID_attr();
	cid_attr->lcid = scid;
	cid_attr->psm = psm;
	cid_attr->ch = ch;
	cid_attr->state = W4_L2CAP_ConnectRsp;	
	cid_list_vec_[ch].push_back(cid_attr);

	// Set fields of the L2CAP header
	l2cap->length = 12;		// Check
	hdr->size() = 12;
	l2cap->cid = 0x01;

	// Set fields in Connect Request Command 
	l2cmd.length = 0x0004;
	l2cmd.code = 0x02;
	l2cmd.identifier = ++identifier_;
	data[0] = psm;
	data[1] = scid;
	downtarget_->recv(p, this);
}	
	
// create and send L2CAP_ConnectRsp
void
L2CAP::sendL2CAP_ConnectRsp (CID_attr* cid, uchar result)
{
	Packet* p = Packet::alloc(8);
	hdr_l2cap* l2cap = HDR_L2CAP(p);
	hdr_bt* bt = HDR_BT(p);
	hdr_cmn* ch = HDR_CMN(p);
	bt->am_addr = cid->ch+1;
	bt->ph.l_ch = 0x0a;
	bt->type = BT_DM1;
	ch->size() = Payload[bt->type];
	L2cmd& l2cmd = l2cap->cmd; 	
	uchar* data = p->accessdata();

	// Set fields of the L2CAP header
	l2cap->length = 16; 	
	l2cap->cid = 0x01;

	// Set fields in Connect Request Command 
	l2cmd.length = 0x0008;
	l2cmd.code = 0x03;
	l2cmd.identifier = cid->identifier;
	data[0] = cid->rcid;
	data[1] = cid->lcid;
	data[2] = result;
	downtarget_->recv(p, this);
}
	
// find CID given the connection handle 
CID_attr*
L2CAP::findCID (uchar cid, uchar connection_handle)
{	
	CID_attr* cid_attr = 0;
	list<CID_attr*>::iterator iter; 
	for (iter = cid_list_vec_[connection_handle].begin(); iter != cid_list_vec_[connection_handle].end(); iter++) {
		CID_attr* cid_attr = (CID_attr*)(*iter);
		if (cid_attr->lcid == cid) 
			return (CID_attr*)(*iter);
	}
	return 0;
	
  printf("L2CAP::findCID\n");


}	

// find CID without connection handle information 
CID_attr*
L2CAP::findCID (uchar cid)
{	
	CID_attr* cid_attr = 0;
	list<CID_attr*>::iterator iter; 
	for (int i=0; i<7; i++) {
		for (iter = cid_list_vec_[i].begin(); iter != cid_list_vec_[i].end(); iter++) 
		{
			CID_attr* cid_attr = (CID_attr*)(*iter);
			if (cid_attr->lcid == cid) 
				return (CID_attr*)(*iter);
		}
	}
	return 0;
}	

